///////////////////////////////////////////////////////////////////////////////
// File name:   main_window.cpp
// Version:     0.0
// Purpose:
// E-mail:      rdpdesk@rdpdesk.com
// Copyright:   (c) 2009-2010 RDPDesk <rdpdesk@rdpdesk.com>
// Licence:     GPL v3
///////////////////////////////////////////////////////////////////////////////

#include "helpbrowser.hpp"

#include <wx/textdlg.h>
#include "wx/filesys.h"
#include "wx/fs_zip.h"

#include "wx/html/helpctrl.h"
#include <wx/stdpaths.h>
//#include <wx/wx.h>

HelpBrowser::HelpBrowser(wxWindow* parent)
: wxDialog(parent, wxID_ANY, _("Documentation"),
           wxDefaultPosition,
           wxSize(800, 500),
	   wxRESIZE_BORDER  | wxDEFAULT_DIALOG_STYLE),
  m_embeddedHtmlHelp(wxHF_EMBEDDED|wxHF_DEFAULT_STYLE)
{
  wxFileSystem::AddHandler(new wxZipFSHandler);
  // Create embedded HTML Help window
  m_embeddedHelpWindow = new wxHtmlHelpWindow;
  // m_embeddedHtmlHelp.UseConfig(config, rootPath); // Can set your own config object here
  m_embeddedHtmlHelp.SetHelpWindow(m_embeddedHelpWindow);

  m_embeddedHelpWindow->Create(this,
                               wxID_ANY,
                               wxDefaultPosition,
                               GetClientSize(),
                               wxTAB_TRAVERSAL|wxNO_BORDER, wxHF_DEFAULT_STYLE);
  wxStandardPaths standartPaths;
#ifdef __WXMSW__
  wxString helpDocumentation = standartPaths.GetResourcesDir() + wxT("\\") + _("doc.zip");
  //wxMessageBox(helpDocumentation);
#endif
#ifdef __WXGTK__
  //FIXME: add support prefix from CONFIG
  //wxString helpDocumentation = standartPaths.GetResourcesDir() +
  //_("doc.zip");
  wxString helpDocumentation = wxString::Format(wxT("%s/%s"), wxT("/usr/share/rdpdesk/"), _("doc.zip"));
#endif
  //std::cout << helpDocumentation.fn_str() << std::endl;
   //std::cout << PREFIX << std::endl;
  if (wxFileExists(helpDocumentation)){
     m_embeddedHtmlHelp.AddBook(wxFileName(helpDocumentation));
     m_embeddedHtmlHelp.Display(_("Contents"));
  }
//  m_embeddedHtmlHelp.Initialize(_T("doc"));
}
